<template>
  <Container class="w-full">
    <SectionHeader icon="mdi-calendar-multiple">
      Последние бронирования
    </SectionHeader>

    <section class="mt-4">
      <EmptyState
        v-if="!guest.bookings.length"
        embedded
        class="py-8 bg-gray-100 min-h-[35dvh]"
      />

      <v-timeline
        v-if="guest.bookings.length"
        class="[&_.v-timeline-divider\_\_dot]:mt-[4px] pt-4"
        density="comfortable"
        align="start"
        side="end"
        dot-color="grey"
        size="20"
        truncate-line="both"
        fill-dot
        hide-opposite
      >
        <v-timeline-item
          v-for="booking in guest.bookings"
          :key="booking.id"
          :dot-color="booking.property.color"
          width="100%"
          side="end"
          class="[&_.v-timeline-item\_\_body]:!px-6"
        >
          <section class="text-xl font-light mr-4 max-w-[300px] truncate">
            {{ booking.property.name }}
          </section>

          <section class="pt-2">
            <BookingStatusDisplay :value="booking.status" />
          </section>

          <section class="pt-2 text-gray-500">
            на {{ getLabeledNightsCount(booking) }}
          </section>

          <section class="pt-1 text-gray-500">
            {{ dt.display(booking.startDate, 'd MMMM') }} -
            {{ dt.display(booking.endDate, 'd MMMM') }}
          </section>

          <v-btn
            text="Подробнее"
            variant="outlined"
            class="text-teal-600 border-teal-600 my-4"
            append-icon="mdi-open-in-new"
            rounded
            @click="$router.push({
              path: `/bookings/${booking.id}`,
              query: { fromGuest: guest.id },
            })"
          />

          <v-divider
            thickness="1"
            class="border-gray-800"
          />
        </v-timeline-item>
      </v-timeline>

      <v-card
        v-if="guest.bookings.length"
        class="text-gray-500 bg-gray-100 rounded-[12px] border-0 mt-4 !shadow-none"
        density="compact"
        :elevation="0"
      >
        <template #text>
          <section class="flex items-start gap-2">
            <span>
              <v-icon
                icon="mdi-information-outline"
                size="large"
              />
            </span>

            <span>
              Отображено до 3 последних бронирований. Полный
              список бронирований этого гостя можно найти
              на соответствующей странице с помощью фильтров
            </span>
          </section>
        </template>
      </v-card>
    </section>
  </Container>
</template>

<script setup lang="ts">
import { useDateTime } from '@/composables';
import { getNightsCount, getNightsLabel } from '@/utils';

import EmptyState from '@/components/layout/EmptyState.vue';
import Container from '@/components/layout/Container.vue';
import SectionHeader from '@/components/layout/SectionHeader.vue';
import BookingStatusDisplay from '@/components/content/BookingStatusDisplay.vue';

defineProps<{ guest: IGuest }>();
const dt = useDateTime();

const getLabeledNightsCount = (booking: Omit<IGeneralBooking, 'guest'>) => {
  const nightsCount = getNightsCount(booking.startDate, booking.endDate);
  const label = getNightsLabel(nightsCount);

  return `${nightsCount} ${label}`;
};
</script>